#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include "list.h"

typedef struct list list_t;
typedef struct node node_t;

struct list
{
  node_t* sentinel;
};

struct node
{
  int element;
  node_t* next;
  node_t* prev;
  /// TODO
};

/// Skapar en ny node med ett givet element (du får ändra denna om du vill)
static node_t* node_create(int element)
{
  node_t* result = calloc(1,sizeof(node_t));
  *result = (node_t) {
                      .element = element
  };
  return result;
}

list_t *ioopm_list_create()
{
  list_t* newlist = calloc(1,sizeof(list_t));
  newlist->sentinel = node_create(-99);
  newlist->sentinel->next = newlist->sentinel;
  newlist->sentinel->prev = newlist->sentinel;
  return newlist;
  /// TODO
}

void ioopm_list_destroy(list_t *list)
{
  node_t* stop = list->sentinel;
  node_t* cursor = stop->next;
  node_t* destroy = cursor;
  while (cursor != stop)
    {
      cursor = cursor->next;
      free(destroy);
      destroy = cursor;
    }
  free(stop);
  free(list);
}

void ioopm_list_prepend(list_t *list, int element)
{
  node_t* prepend = node_create(element);
  prepend->prev = list->sentinel;
  prepend->next = list->sentinel->next;
  prepend->next->prev = prepend;
  prepend->prev->next = prepend;
  /// TODO
}

void ioopm_list_append(list_t *list, int element)
{
  node_t* append = node_create(element);
  append->next = list->sentinel;
  append->prev = list->sentinel->prev;
  append->next->prev = append;
  append->prev->next = append;
  /// TODO
}

static bool valid_index(list_t *list, int index)
{
  int size = ioopm_list_size(list);
  return -size <= index && index < size;
  /// TODO
}

bool ioopm_list_remove(list_t *list, int index)
{
  bool remove = false;
  if (valid_index(list, index))
    {
      if (index < 0) { index = ioopm_list_size(list) + index; } // Now index >= 0.
      size_t i = 0;
      // bool contains = false;
      node_t* stop = list->sentinel;
      node_t* cursor = stop->next;
      while (cursor != stop)
        {
          if (i == index) {
            cursor->prev->next = cursor->next;
            cursor->next->prev = cursor->prev;
            free(cursor);
            cursor = stop;
          } else {
            cursor = cursor->next;
            ++i;
          }
        }
    }
  return remove;
  /// TODO
}

int *ioopm_list_get(list_t *list, int index)
{
  int* get = NULL;//calloc(1,sizeof(int)); // TODO: do not allocate!
  if (valid_index(list, index))
    {
      if (index < 0) { index = ioopm_list_size(list) + index; } // Now index >= 0.
      size_t i = 0;
      // bool contains = false;
      node_t* stop = list->sentinel;
      node_t* cursor = stop->next;
      while (cursor != stop)
        {
          if (i == index) {
            get = &(cursor->element);
            cursor = stop;
          } else {
            cursor = cursor->next;
            ++i;
          }
        }
    }
  return get;
  /// TODO
}

/// Du får ändra på denna kod om du vill -- t.ex. för att
/// den inte funkar enligt din design, eller för att det
/// är enklare att skriva om den än att förstå den!
bool ioopm_list_contains(list_t *list, int element)
{
  bool contains = false;
  node_t* stop = list->sentinel;
  node_t* cursor = stop->next;
  while (cursor != stop)
    {
      if (cursor->element == element) {
        contains = true;
        cursor = stop;
      } else {
        cursor = cursor->next;
      }
    }
  return contains;
}

int ioopm_list_size(list_t *list)
{
  int size = 0;
  node_t* stop = list->sentinel;
  node_t* cursor = stop->next;
  while (cursor != stop)
    {
      ++size;
      cursor = cursor->next;
    }
  return size;
  // return 4242;
  /// TODO
}
